coreutils
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

[PATCH] refactor expensive code in misc/stty [was: amendments to backtic


From: Bernhard Voelker
Subject: [PATCH] refactor expensive code in misc/stty [was: amendments to backtick-removing series]
Date: Thu, 05 Apr 2012 09:02:34 +0200
User-agent: Mozilla/5.0 (X11; Linux x86_64; rv:11.0) Gecko/20120312 Thunderbird/11.0


On 04/04/2012 05:29 PM, Jim Meyering wrote:
> Bernhard Voelker wrote:
>> I think this code hasn't been run for a very long time,
>> because RUN_LONG_TESTS is not set anywhere.
>>
>>   if test -n "$RUN_LONG_TESTS"; then
>>     # Take them in pairs.
>>
>> So shouldn't this ~20sec part of the test be moved into
>> a very_expensive_ guard?
> 
> Good idea.
> Wow.  That code hasn't been touch since the last millennium ;-)
> 
>> And if that part runs, then the test fails (at least here)
>> because of parenb and cread options.
>>
>> Do they have to be excluded?
> 
> That makes sense, since parenb and cread are already exempted in
> the preceding one-at-a-time on/off tests.

Besides factoring out the expensive code, I found out
that "iutf8" was missing in the option list.

* [PATCH 1/2] tests: add iutf8 option to misc/stty
* [PATCH 2/2] tests: factor out expensive "pairs" code of misc/stty

I'm not happy that the REV_* list is doubled now,
but I'm optimistic that with the "See also:" comment
we're quite safe that both places will be updated next
time.

Have a nice day,
Berny



>From f71ed9ae1a9699e000a98c26dae4db96a628d657 Mon Sep 17 00:00:00 2001
From: Bernhard Voelker <address@hidden>
Date: Thu, 5 Apr 2012 08:01:43 +0200
Subject: [PATCH 1/2] tests: add iutf8 option to misc/stty

* tests/misc/stty: Add iutf8 to the list of REV_* options.
That option has been implemented in commit v5.2.1-193-g733e79e.
---
 tests/misc/stty |   14 +++++++-------
 1 files changed, 7 insertions(+), 7 deletions(-)

diff --git a/tests/misc/stty b/tests/misc/stty
index 1b082c2..cfc70c1 100755
--- a/tests/misc/stty
+++ b/tests/misc/stty
@@ -29,13 +29,13 @@ REV_parenb=1 REV_parodd=1 REV_hupcl=1 REV_hup=1 
REV_cstopb=1 REV_cread=1
 REV_clocal=1 REV_crtscts=1 REV_ignbrk=1 REV_brkint=1 REV_ignpar=1
 REV_parmrk=1 REV_inpck=1 REV_istrip=1 REV_inlcr=1 REV_igncr=1 REV_icrnl=1
 REV_ixon=1 REV_ixoff=1 REV_tandem=1 REV_iuclc=1 REV_ixany=1 REV_imaxbel=1
-REV_opost=1 REV_olcuc=1 REV_ocrnl=1 REV_onlcr=1 REV_onocr=1 REV_onlret=1
-REV_ofill=1 REV_ofdel=1 REV_isig=1 REV_icanon=1 REV_iexten=1 REV_echo=1
-REV_echoe=1 REV_crterase=1 REV_echok=1 REV_echonl=1 REV_noflsh=1
-REV_xcase=1 REV_tostop=1 REV_echoprt=1 REV_prterase=1 REV_echoctl=1
-REV_ctlecho=1 REV_echoke=1 REV_crtkill=1 REV_evenp=1 REV_parity=1
-REV_oddp=1 REV_nl=1 REV_cooked=1 REV_raw=1 REV_pass8=1 REV_litout=1
-REV_cbreak=1 REV_decctlq=1 REV_tabs=1 REV_lcase=1 REV_LCASE=1
+REV_iutf8=1 REV_opost=1 REV_olcuc=1 REV_ocrnl=1 REV_onlcr=1 REV_onocr=1
+REV_onlret=1 REV_ofill=1 REV_ofdel=1 REV_isig=1 REV_icanon=1 REV_iexten=1
+REV_echo=1 REV_echoe=1 REV_crterase=1 REV_echok=1 REV_echonl=1
+REV_noflsh=1 REV_xcase=1 REV_tostop=1 REV_echoprt=1 REV_prterase=1
+REV_echoctl=1 REV_ctlecho=1 REV_echoke=1 REV_crtkill=1 REV_evenp=1
+REV_parity=1 REV_oddp=1 REV_nl=1 REV_cooked=1 REV_raw=1 REV_pass8=1
+REV_litout=1 REV_cbreak=1 REV_decctlq=1 REV_tabs=1 REV_lcase=1 REV_LCASE=1


 saved_state=.saved-state
-- 
1.7.7


>From 7f557d6788e2d096269f24effbc18bbd67597a1f Mon Sep 17 00:00:00 2001
From: Bernhard Voelker <address@hidden>
Date: Thu, 5 Apr 2012 08:38:32 +0200
Subject: [PATCH 2/2] tests: factor out expensive "pairs" code of misc/stty

* tests/Makefile.am: Add misc/stty-pairs.
* tests/misc/stty: Factor out expensive "pairs" code into new test.
* tests/misc/stty-pairs: Added new test. Code added from misc/stty.
Mark this as an expensive test. Skip 'parenb' and 'cread' options,
as these tests are known to fail.
---
 tests/Makefile.am     |    1 +
 tests/misc/stty       |   24 +--------------
 tests/misc/stty-pairs |   77 +++++++++++++++++++++++++++++++++++++++++++++++++
 3 files changed, 79 insertions(+), 23 deletions(-)
 create mode 100755 tests/misc/stty-pairs

diff --git a/tests/Makefile.am b/tests/Makefile.am
index 011051a..86afbc2 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -274,6 +274,7 @@ TESTS =                                             \
   misc/stdbuf                                  \
   misc/stty                                    \
   misc/stty-invalid                            \
+  misc/stty-pairs                              \
   misc/stty-row-col                            \
   misc/su-fail                                 \
   misc/sum                                     \
diff --git a/tests/misc/stty b/tests/misc/stty
index cfc70c1..40e6ce6 100755
--- a/tests/misc/stty
+++ b/tests/misc/stty
@@ -25,6 +25,7 @@ trap '' TTOU # Ignore SIGTTOU

 # The following list of reversible options was generated with
 # grep -w REV stty.c|sed -n '/^  {"/{s//REV_/;s/".*/=1/;p;}'|fmt
+# See also: tests/misc/stty-pairs.
 REV_parenb=1 REV_parodd=1 REV_hupcl=1 REV_hup=1 REV_cstopb=1 REV_cread=1
 REV_clocal=1 REV_crtscts=1 REV_ignbrk=1 REV_brkint=1 REV_ignpar=1
 REV_parmrk=1 REV_inpck=1 REV_istrip=1 REV_inlcr=1 REV_igncr=1 REV_icrnl=1
@@ -76,29 +77,6 @@ for opt in $options; do
   fi
 done

-if test -n "$RUN_LONG_TESTS"; then
-  # Take them in pairs.
-  for opt1 in $options; do
-    echo .|tr -d '\n'
-    for opt2 in $options; do
-
-      stty $opt1 $opt2 || fail=1
-
-      eval rev1=\$REV_$opt1
-      eval rev2=\$REV_$opt2
-      if test -n "$rev1"; then
-        stty -$opt1 $opt2 || fail=1
-      fi
-      if test -n "$rev2"; then
-        stty $opt1 -$opt2 || fail=1
-      fi
-      if test "$rev1$rev2" = 11; then
-        stty -$opt1 -$opt2 || fail=1
-      fi
-    done
-  done
-fi
-
 stty $(cat $saved_state)

 Exit $fail
diff --git a/tests/misc/stty-pairs b/tests/misc/stty-pairs
new file mode 100755
index 0000000..7efc95b
--- /dev/null
+++ b/tests/misc/stty-pairs
@@ -0,0 +1,77 @@
+#!/bin/sh
+# Make sure stty can parse most of its options - in pairs [expensive].
+
+# Copyright (C) 1998-2012 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ stty
+
+expensive_
+
+# Make sure there's a tty on stdin.
+require_controlling_input_terminal_
+trap '' TTOU # Ignore SIGTTOU
+
+# The following list of reversible options was generated with
+# grep -w REV stty.c|sed -n '/^  {"/{s//REV_/;s/".*/=1/;p;}'|fmt
+# See also: tests/misc/stty.
+REV_parenb=1 REV_parodd=1 REV_hupcl=1 REV_hup=1 REV_cstopb=1 REV_cread=1
+REV_clocal=1 REV_crtscts=1 REV_ignbrk=1 REV_brkint=1 REV_ignpar=1
+REV_parmrk=1 REV_inpck=1 REV_istrip=1 REV_inlcr=1 REV_igncr=1 REV_icrnl=1
+REV_ixon=1 REV_ixoff=1 REV_tandem=1 REV_iuclc=1 REV_ixany=1 REV_imaxbel=1
+REV_iutf8=1 REV_opost=1 REV_olcuc=1 REV_ocrnl=1 REV_onlcr=1 REV_onocr=1
+REV_onlret=1 REV_ofill=1 REV_ofdel=1 REV_isig=1 REV_icanon=1 REV_iexten=1
+REV_echo=1 REV_echoe=1 REV_crterase=1 REV_echok=1 REV_echonl=1
+REV_noflsh=1 REV_xcase=1 REV_tostop=1 REV_echoprt=1 REV_prterase=1
+REV_echoctl=1 REV_ctlecho=1 REV_echoke=1 REV_crtkill=1 REV_evenp=1
+REV_parity=1 REV_oddp=1 REV_nl=1 REV_cooked=1 REV_raw=1 REV_pass8=1
+REV_litout=1 REV_cbreak=1 REV_decctlq=1 REV_tabs=1 REV_lcase=1 REV_LCASE=1
+
+
+saved_state=.saved-state
+stty --save > $saved_state || fail=1
+stty $(cat $saved_state) || fail=1
+
+# Build a list of all boolean options stty accepts on this system.
+# Don't depend on terminal width.  Put each option on its own line,
+# remove all non-boolean ones, remove 'parenb' and 'cread' explicitly,
+# then remove any leading hyphens.
+sed_del='/^speed/d;/^rows/d;/^columns/d;/ = /d;s/parenb//;s/cread//'
+options=$(stty -a | tr -s ';' '\n' | sed "s/^ //;$sed_del;s/-//g")
+
+# Take them in pairs, with and without the leading '-'.
+for opt1 in $options; do
+  for opt2 in $options; do
+
+    stty $opt1 $opt2 || fail=1
+
+    eval rev1=\$REV_$opt1
+    eval rev2=\$REV_$opt2
+    if test -n "$rev1"; then
+      stty -$opt1 $opt2 || fail=1
+    fi
+    if test -n "$rev2"; then
+      stty $opt1 -$opt2 || fail=1
+    fi
+    if test "$rev1$rev2" = 11; then
+      stty -$opt1 -$opt2 || fail=1
+    fi
+  done
+done
+
+stty $(cat $saved_state)
+
+Exit $fail
-- 
1.7.7



reply via email to

[Prev in Thread] Current Thread [Next in Thread]